# Room Architect Tool

# NOTE: This is NOT a MOD, if you download it like a mod it will do ***NOTHING***.

An up-to-date version of the [original](https://modworkshop.net/mod/27087) with multiple new features, but exports as a unique file type which can be read by Alexandrias DungeonAPI.


## Features
- Node Tool, for placing down node pathways for objects like saws and minecarts.
- Custom Enemy / Object support
- Various new objects that can be used + sorted categories
- New enemy wave triggers for each individual enemy wave.
- Property tool, which allows you to alter the properties of certain objects.
- New QoL tools, such as the Rectangle Tool and Ellipse tool.
- Canvas resizing
- More that I likely didn't mention

## Hotkeys

| Button  | Function |
| ------------- |:-------------:|
| CTRL + S     | Save / Save As    |
| CTRL + N      | New File     |
| CTRL + O     | Open File     |
| CTRL + Z     | Undo  (Janky, don't rely on it)   |
| CTRL + Left Shift + Z     | Redo (Janky, don't rely on it)    |


## Mode Hotkeys

| Button  | Function |
| ------------- |:-------------:|
| G     | Toggle Visual Grid     |
| N     | Toggle Node Mode    |
| X (Only while in Node Mode)     | Toggle Node Path Visualizer     |


## Tool Hotkeys
| Button  | Function |
| ------------- |:-------------:|
| E     | Eraser Tool    |
| B     | Brush Tool    |
| F     | Bucket Tool    |
| L     | Line Tool    |
| R     | Rectangle Tool    |
| C     | Ellipse Tool    |

# V.3.0.6
- Fixed error that caused nodes to potentially not appear when loading a room.
- Fixed error related to certain properties with pathing based objects.


# V.3.0.5

- Hopefully finally fixed issues relating to adding custom assets.
- Reworded overriding custom assets panel.
- Increased the size of the notification pop-up.
- Fixed bug relating to ambient light values not saving properly. 

# V.3.0.4

- Added "Pause movement for X seconds here" property to Nodes.
- Added "Pause movement for X seconds after reachning Node" property to several pathing objects.

# V.3.0.3

- Hopefully fixed issue with importing custom assets repeatedly in the same session.


# V.3.0.2
- Made custom assets no longer blurry.
- Fixed custom placeable input box not being the right shape.


# V.3.0.1

- New:
- Added unused Grass Tile.
- Holding Shift while hovering over a Floor Visual Image for visual layouts now creates a larger version of that image for looking at. 

-Fixes:
- Added nullcheck for custom enemies.


# V.3.0.0

- New:

- New Copy Tool
- New Brush Size option
- New Tile Descriptions option
- New Placeable tiles
- New Traps
- New Pathing Traps
- Drop Traps
- New Decorations
- New NPCs
- New Special Objects
- Custom Lighting
- Door Entrances / Exits
- Control Visual Subtypes
- New Room Pools
- New Properties
- New QoL features

- Fixes:
- Many fixes in regards to Nodes.
- Some other stamm stuff

Special Thanks to:
- Bobot (For getting most of this working, along with DungeonAPI changes)
- KyleTheScientist (Original Creator of RAT)
- spcreat (Created the original systems behind categories, shape tools and a property system)
- Nevernamed (Planning and organisation)
- Some Bunny (General bug fixing)

